DECLARE SUB loadanim (file$)
DECLARE SUB roteixo (objt!)
'G Soft. Maio de 1999
'Crash Neth -=> crash_neth@lords.com <=-

DECLARE SUB getpoints (file$)
DECLARE SUB calctela (l!, objy!, xtela!, ytela!) 'sub que rotaciona os pontos
CLS : SCREEN 9
TYPE pnt
  x AS INTEGER: y AS INTEGER: z AS INTEGER
END TYPE
TYPE objeto
  pi AS INTEGER: pf AS INTEGER: li AS INTEGER: lf AS INTEGER
  x AS INTEGER: y AS INTEGER: z AS INTEGER
  ax AS INTEGER: ay AS INTEGER: az AS INTEGER
  nome AS STRING * 20: eixo AS INTEGER
  eixox AS INTEGER: eixoy AS INTEGER: eixoz AS INTEGER
END TYPE
TYPE lin
  pi AS INTEGER: pf AS INTEGER: cor AS INTEGER
END TYPE
TYPE objanim
  eixox AS INTEGER: eixoy AS INTEGER: eixoz AS INTEGER
END TYPE
TYPE scr
  obj AS INTEGER: eixo AS INTEGER: steps AS INTEGER: nquad AS INTEGER
END TYPE
maxp = 100: maxob = 50: frames = 100: scriptlines = 100
DIM SHARED ponto(maxp, maxob) AS pnt, linha(maxp, maxob) AS lin, obj(maxp) AS objeto
DIM SHARED olho.x, olho.y, olho.z, olho.ax, olho.ay, olho.az, tob, som
DIM SHARED xmax, ymax, xmin, ymin, ax, ay, az, pdf(maxp), tl, var$(100)
DIM SHARED fax, fay, faz, fdx, fdy, fdz, fox, foy, foz, hierachy(maxob), hf
DIM SHARED eixox(maxob), eixoy(maxob), eixoz(maxob), ff(maxob), fr
DIM SHARED script(scriptlines) AS scr, animat(frames, maxob) AS objanim

fr = 100
getpoints "robot.g3d"
loadanim "robot.scr"

DIM SHARED px(maxp, tob), py(maxp, tob)

inicio:

'tabela de seno e cosseno
DIM SHARED seno(360), cose(360)
FOR i = 0 TO 360
  seno(i) = SIN(i * .0175)
  cose(i) = COS(i * .0175)
NEXT i

'=========
'Variaveis
'=========
'duas para page fliping
Ws = 1: Vs = 0
'angulos inicias
ax = fax: ay = fay: az = faz - 180
'deltas de rotao
deltax = fdx: deltay = fdy: deltaz = fdz
'Posiao do olho
olho.x = fox: olho.y = foy: olho.z = foz
opm = 2


    FOR aaa = 1 TO tob
     aa = hierachy(aaa)
     roteixo aa
    NEXT aaa


'=====================================================================
'                     LOOP       Principal
'=====================================================================

DO

  SWAP Ws, Vs
  SCREEN 9, , Ws, Vs
  
  ax = ax + deltax
  IF ax > 360 THEN ax = 0 + (ax - 360)
  IF ax < 0 THEN ax = 360 + ax
  ay = ay + deltay
  IF ay > 360 THEN ay = 0 + (ay - 360)
  IF ay < 0 THEN ay = 360 + ay
  az = az + deltaz
  IF az > 360 THEN az = 0 + (az - 360)
  IF az < 0 THEN az = 360 + az

  FOR aaa = 1 TO tob
   aa = hierachy(aaa)
   FOR l = 1 TO obj(aa).pf
     calctela l, aa, xtela, ytela
   NEXT l
  NEXT aaa
 
  CLS
  LOCATE 1, 1: COLOR linha(1, opm).cor: PRINT "O: "; opm

  FOR ob = 1 TO tob
   FOR alin = 1 TO obj(ob).lf
     P = linha(alin, ob).pi
     pp = linha(alin, ob).pf
     LINE (px(P, ob), py(P, ob))-(px(pp, ob), py(pp, ob)), linha(alin, ob).cor
   NEXT alin
  NEXT ob

  WAIT &H3DA, 8

  x$ = INKEY$

  IF LCASE$(x$) = "c" THEN
    ax = fax: ay = fay: az = faz - 180
    deltax = fdx: deltay = fdy: deltaz = fdz
    olho.x = fox: olho.y = foy: olho.z = foz
  END IF
  
  IF x$ <> "" THEN
    IF x$ = CHR$(27) THEN EXIT DO
    IF x$ = CHR$(0) + "H" THEN
      deltax = deltax + 2
      IF deltax > 30 THEN deltax = 30
    END IF
    IF x$ = CHR$(0) + "P" THEN
      deltax = deltax - 2
      IF deltax < -30 THEN deltax = -30
    END IF
    IF x$ = CHR$(0) + "Q" THEN
      deltaz = deltaz + 2
      IF deltaz > 30 THEN deltaz = 30
    END IF
    IF x$ = CHR$(0) + "I" THEN
      deltaz = deltaz - 2
      IF deltaz < -30 THEN deltaz = -30
    END IF
    IF x$ = CHR$(0) + "M" THEN
      deltay = deltay + 2
      IF deltay > 30 THEN deltay = 30
    END IF
    IF x$ = CHR$(0) + "K" THEN
      deltay = deltay - 2
      IF deltay < -30 THEN deltay = -30
    END IF

    IF x$ = "8" THEN olho.y = olho.y + 10
    IF x$ = "2" THEN olho.y = olho.y - 10
    IF x$ = "4" THEN olho.x = olho.x + 10
    IF x$ = "6" THEN olho.x = olho.x - 10
    IF x$ = "+" THEN olho.z = olho.z + 10
    IF x$ = "-" THEN olho.z = olho.z - 10


    l$ = LCASE$(x$)

    IF l$ = "w" THEN
10    opm = opm + 1
      IF opm > tob THEN opm = 1
      IF obj(opm).eixo < 1 THEN GOTO 10
    END IF

    IF l$ = "s" THEN
20    opm = opm - 1
      IF opm < 1 THEN opm = tob
      IF obj(opm).eixo < 1 THEN GOTO 20
    END IF

    IF l$ = "q" OR l$ = "a" OR l$ = "w" OR l$ = "s" OR l$ = "e" OR l$ = "d" THEN
     IF obj(opm).eixo = 1 THEN
      IF l$ = "q" THEN
       obj(opm).ax = obj(opm).ax + 5
       IF obj(opm).ax > 360 THEN obj(opm).ax = 0 + (obj(opm).ax - 360)
      END IF
    
      IF l$ = "a" THEN
       obj(opm).ax = obj(opm).ax - 5
       IF obj(opm).ax < 0 THEN obj(opm).ax = 360 + obj(opm).ax
      END IF
     END IF

     IF obj(opm).eixo = 2 THEN
      IF l$ = "w" THEN
       obj(opm).ay = obj(opm).ay + 5
       IF obj(opm).ay > 360 THEN obj(opm).ay = 0 + (obj(opm).ay - 360)
      END IF

      IF l$ = "s" THEN
       obj(opm).ay = obj(opm).ay - 5
       IF obj(opm).ay < 0 THEN obj(opm).ay = 360 + obj(opm).ay
      END IF
     END IF

     IF obj(opm).eixo = 3 THEN
      IF l$ = "e" THEN
       obj(opm).az = obj(opm).az + 5
       IF obj(opm).az > 360 THEN obj(opm).az = 0 + (obj(opm).az - 360)
      END IF

      IF l$ = "d" THEN
       obj(opm).az = obj(opm).az - 5
       IF obj(opm).az < 0 THEN obj(opm).az = 360 + obj(opm).az
      END IF
     END IF

     FOR aaa = 1 TO tob
      aa = hierachy(aaa)
      roteixo aa
     NEXT aaa
     IF som = 1 THEN SOUND 2000, .1
   END IF

  END IF

LOOP
LOCATE 1, 1: PRINT "Angulos dos objetos:"
FOR i = 1 TO tob
  COLOR linha(1, i).cor
  PRINT i; ".", "x: "; obj(i).ax, "y: "; obj(i).ay, "z: "; obj(i).az
NEXT i
COLOR 7
PRINT
PRINT "Posio do olho:"
PRINT "x: "; olho.x, "y: "; olho.y, "z: "; olho.z
PRINT
PRINT "Angulos do olho:"
PRINT "x: "; ax, "y: "; ay, "z: "; az - 180
SWAP Vs, Ws
SCREEN 9, , Ws, Vs

SUB calctela (l, objt, xtela, ytela)

    FOR i = 2 TO hf
      IF objt = hierachy(i) THEN
        obps = hierachy(i - 1)
        nobps = i - 1
        GOTO ok
      END IF
    NEXT i
ok:

      aax = obj(objt).ax
      aay = obj(objt).ay
      aaz = obj(objt).az

     IF obj(objt).eixo = 1 THEN
      FOR ss = 1 TO nobps
        obps = hierachy(ss)
        aax = (aax + obj(obps).ax) MOD 360
        aay = (aay + obj(obps).ay) MOD 360
        aaz = (aaz + obj(obps).az) MOD 360
        IF objt = 6 THEN INPUT hfd
      NEXT ss
     END IF
    
    xxx = ponto(l, objt).x * cose(aax) - ponto(l, objt).y * seno(aax)
    yyy = ponto(l, objt).x * seno(aax) + ponto(l, objt).y * cose(aax)
    xi = xxx * cose(aay) + ponto(l, objt).z * seno(aay)
    zzz = -xxx * seno(aay) + ponto(l, objt).z * cose(aay)
    yi = yyy * cose(aaz) - ponto(l, objt).z * seno(aaz)
    zi = yi * seno(aaz) + zzz * cose(aaz)
    
    pontox = xi + obj(obps).eixox
    pontoy = yi + obj(obps).eixoy
    pontoz = zi + obj(obps).eixoz

    xnewb = pontox * cose(ax) - pontoy * seno(ax)
    ynewb = pontox * seno(ax) + pontoy * cose(ax)
    xb = xnewb * cose(ay) + pontoz * seno(ay)
    znb = -xnewb * seno(ay) + pontoz * cose(ay)
    yb = ynewb * cose(az) - znb * seno(az)
    zb = yb * seno(az) + znb * cose(az)

    xnew = xb * cose(olho.ax) - yb * seno(olho.ax)
    ynew = xb * seno(olho.ax) + yb * cose(olho.ax)
    x = xnew * cose(olho.ay) + zb * seno(olho.ay)
    zn = -xnew * seno(olho.ay) + zb * cose(olho.ay)
    y = ynew * cose(olho.az) - zn * seno(olho.az)
    z = y * seno(olho.az) + zn * cose(olho.az)

    xolho = x - olho.x
    yolho = y - olho.y
    zolho = z - olho.z
    
    xtela = ((xolho / zolho) * 640 + 390) * .8: px(l, objt) = xtela
    ytela = (yolho / zolho) * 350 + 175: py(l, objt) = ytela
END SUB

SUB getpoints (file$)
OPEN file$ FOR INPUT AS #1
LINE INPUT #1, header$
ver = VAL(RIGHT$(header$, 3))
IF ver < 3 THEN
  PRINT "Este programa  para arquivos v 3.0"
  END
END IF
IF LEFT$(header$, 16) <> "G Soft 3D file v" THEN
  BEEP
  PRINT "No  um arquivo G Soft 3D."
  END
END IF
LINE INPUT #1, totobfile$
tobfile = VAL(totobfile$)
objback:
tp = 0: tl = 0
LINE INPUT #1, lin$
obj = VAL(RIGHT$(lin$, 2))
obi$ = RIGHT$(STR$(obj), LEN(STR$(obj)) - 1)
a = INSTR(lin$, "-")
obj(obj).nome = LEFT$(lin$, a - 1)
DO WHILE NOT EOF(1)
  LINE INPUT #1, lin$
  IF lin$ = "fdp" GOTO linhas
  FOR i = 1 TO LEN(lin$)
    ch$ = MID$(lin$, i, 1)
    IF ch$ = "," THEN
      vr = vr + 1
      GOTO pula
    END IF
    var$(vr) = var$(vr) + ch$
pula:
  NEXT i
faz:
  tp = tp + 1
  ponto(tp, obj).x = VAL(var$(0))
  ponto(tp, obj).y = VAL(var$(1))
  ponto(tp, obj).z = VAL(var$(2))
  FOR aa = 0 TO 2
    var$(aa) = ""
  NEXT aa
  vr = 0
LOOP
linhas:
vr = 0
FOR aa = 0 TO 2
  var$(aa) = ""
NEXT aa
DO WHILE NOT EOF(1)
  LINE INPUT #1, lin$
  IF lin$ = "fdl" GOTO objetos
  FOR i = 1 TO LEN(lin$)
    ch$ = MID$(lin$, i, 1)
    IF ch$ = "'" THEN GOTO fazz
    IF ch$ = "," THEN
      vr = vr + 1
      GOTO apula
    END IF
    var$(vr) = var$(vr) + ch$
apula:
  NEXT i
fazz:
  tl = tl + 1
  linha(tl, obj).pi = VAL(var$(0))
  linha(tl, obj).pf = VAL(var$(1))
  linha(tl, obj).cor = VAL(var$(2))
  FOR aa = 0 TO 2
    var$(aa) = ""
  NEXT aa
  vr = 0
LOOP
objetos:
vr = 0
DO WHILE NOT EOF(1)
  LINE INPUT #1, lin$
  IF lin$ = "fdobj" + totobfile$ GOTO screensetup
  IF LEFT$(lin$, 5) = "fdobj" GOTO objback
  FOR i = 1 TO LEN(lin$)
    ch$ = MID$(lin$, i, 1)
    IF ch$ = "'" THEN GOTO faze
    IF ch$ = "," THEN
      vr = vr + 1
      GOTO pula2
    END IF
    var$(vr) = var$(vr) + ch$
pula2:
  NEXT i
faze:
  tob = tob + 1
  obj(tob).pf = tp
  obj(tob).lf = tl
  obj(tob).ax = VAL(var$(0))
  obj(tob).ay = VAL(var$(1))
  obj(tob).az = VAL(var$(2))
  obj(tob).pf = obj(tob).pf + 1
  ponto(obj(tob).pf, obj).x = VAL(var$(3))
  ponto(obj(tob).pf, obj).y = VAL(var$(4))
  ponto(obj(tob).pf, obj).z = VAL(var$(5))
  obj(tob).eixox = VAL(var$(3))
  obj(tob).eixoy = VAL(var$(4))
  obj(tob).eixoz = VAL(var$(5))
  obj(tob).eixo = VAL(var$(6))
  FOR aa = 0 TO 6
    var$(aa) = ""
  NEXT aa
  vr = 0
LOOP
screensetup:
vr = 0
DO WHILE NOT EOF(1)
LINE INPUT #1, lin$
IF lin$ = "eof" GOTO iniobjpos
ls = ls + 1
FOR i = 1 TO LEN(lin$)
    ch$ = MID$(lin$, i, 1)
    IF ch$ = "'" THEN GOTO fazi
    IF ch$ = "," THEN
      vr = vr + 1
      GOTO apula2
    END IF
    var$(vr) = var$(vr) + ch$
apula2:
NEXT i
fazi:
SELECT CASE ls
  CASE 1
    fax = VAL(var$(0))
    fay = VAL(var$(1))
    faz = VAL(var$(2))
    fdx = VAL(var$(3))
    fdy = VAL(var$(4))
    fdz = VAL(var$(5))
    fox = VAL(var$(6))
    foy = VAL(var$(7))
    foz = VAL(var$(8))
    som = VAL(var$(9))
  CASE 2
    hierachy$ = lin$
END SELECT
LOOP
iniobjpos:
FOR aa = 0 TO 9
    var$(aa) = ""
NEXT aa
vr = 1
FOR i = 1 TO LEN(hierachy$)
    ch$ = MID$(hierachy$, i, 1)
    IF ch$ = "," THEN
      vr = vr + 1
      GOTO pula2a
    END IF
    var$(vr) = var$(vr) + ch$
pula2a:
NEXT i
FOR i = 1 TO vr - 1
  hierachy(i) = VAL(var$(i))
NEXT i
hf = vr - 1
CLOSE #1
END SUB

SUB loadanim (file$)
OPEN file$ FOR INPUT AS #1
LINE INPUT #1, header$
ver = VAL(RIGHT$(header$, 3))
IF LEFT$(header$, 26) <> "G Soft 3D animation file v" THEN
  BEEP
  PRINT "No  um arquivo de animao G Soft 3D."
  END
END IF
IF ver < 1 THEN
  PRINT "Este programa  para arquivos v 1.0"
  END
END IF
FOR aa = 0 TO 3
    var$(aa) = ""
NEXT aa
DO WHILE NOT EOF(1)
  LINE INPUT #1, lin$
  IF lin$ = "fdmo" GOTO proximo
  vr = 0
  FOR i = 1 TO LEN(lin$)
    ch$ = MID$(lin$, i, 1)
    IF ch$ = "," THEN
      vr = vr + 1
      GOTO spula
    END IF
    var$(vr) = var$(vr) + ch$
spula:
  NEXT i
  tps = tps + 1
  script(tps).obj = VAL(var$(0))
  script(tps).eixo = VAL(var$(1))
  script(tps).steps = VAL(var$(2))
  script(tps).nquad = VAL(var$(3))
  FOR aa = 0 TO 3
    var$(aa) = ""
  NEXT aa
  vr = 0
LOOP

proximo:
FOR i = 1 TO fr
 FOR obj = 1 TO tob
  animat(i, obj).eixox = obj(obj).eixox
  animat(i, obj).eixoy = obj(obj).eixoy
  animat(i, obj).eixoz = obj(obj).eixoz
 NEXT obj
NEXT i
FOR i = 1 TO tob
  ff(i) = 1
NEXT i

FOR i = 1 TO tps
  obj = script(i).obj: stp = script(i).steps
  ex = obj(obj).ax
  ey = obj(obj).ay
  ez = obj(obj).az
  fi = ff(obj)
  ff(obj) = ff(obj) + script(i).nquad
  FOR f = fi TO ff(obj)
    SELECT CASE script(i).eixo
      CASE 1
        ex = (ex + stp) MOD 360
        animat(f, obj).eixox = ex
      CASE 2
        ey = (ey + stp) MOD 360
        animat(f, obj).eixoy = ey
      CASE 3
        ez = (ez + stp) MOD 360
        animat(f, obj).eixoz = ez
    END SELECT
  NEXT f
  FOR f = ff(obj) TO fr
    animat(f, obj).eixox = ex
    animat(f, obj).eixoy = ey
    animat(f, obj).eixoz = ez
  NEXT f
NEXT i
  
END SUB

SUB roteixo (objt)

    FOR i = 2 TO hf
      IF objt = hierachy(i) THEN
        obps = hierachy(i - 1)
        GOTO aok
      END IF
    NEXT i
aok:

    aax = obj(objt).ax
    aay = obj(objt).ay
    aaz = obj(objt).az

    IF obj(obps).eixo = 1 THEN
      aax = (aax + obj(obps).ax) MOD 360
      aay = (aay + obj(obps).ay) MOD 360
      aaz = (aaz + obj(obps).az) MOD 360
    END IF
    
    l = obj(objt).pf

    xxx = ponto(l, objt).x * cose(aax) - ponto(l, objt).y * seno(aax)
    yyy = ponto(l, objt).x * seno(aax) + ponto(l, objt).y * cose(aax)
    obj(objt).eixox = xxx * cose(aay) + ponto(l, objt).z * seno(aay)
    zzz = -xxx * seno(aay) + ponto(l, objt).z * cose(aay)
    obj(objt).eixoy = yyy * cose(aaz) - ponto(l, objt).z * seno(aaz)
    obj(objt).eixoz = obj(objt).eixoy * seno(aaz) + zzz * cose(aaz)

    obj(objt).eixox = obj(objt).eixox + obj(obps).eixox
    obj(objt).eixoy = obj(objt).eixoy + obj(obps).eixoy
    obj(objt).eixoz = obj(objt).eixoz + obj(obps).eixoz
END SUB

