'G Soft. Maio de 1999
'Crash Neth -=> crash_neth@lords.com <=-


DECLARE SUB getpoints (file$)
DECLARE SUB calctela (l!, objy!, xtela!, ytela!) 'sub que rotaciona os pontos
DECLARE SUB loadanim (file$)
DECLARE SUB roteixo (objt!)

CLS : SCREEN 9

arq1$ = "robot.g3d": arq2$ = "robot.scr"

TYPE pnt
  x AS INTEGER: y AS INTEGER: z AS INTEGER
END TYPE
TYPE objeto
  pi AS INTEGER: pf AS INTEGER: li AS INTEGER: lf AS INTEGER
  x AS INTEGER: y AS INTEGER: z AS INTEGER
  ax AS INTEGER: ay AS INTEGER: az AS INTEGER
  nome AS STRING * 20: eixo AS INTEGER
  eixox AS INTEGER: eixoy AS INTEGER: eixoz AS INTEGER
END TYPE
TYPE lin
  pi AS INTEGER: pf AS INTEGER: cor AS INTEGER
END TYPE
TYPE objanim
  eixox AS INTEGER: eixoy AS INTEGER: eixoz AS INTEGER
  olhox AS INTEGER: olhoy AS INTEGER: olhoz AS INTEGER
  ax AS INTEGER: ay AS INTEGER: az AS INTEGER
END TYPE
TYPE scr
  obj AS INTEGER: eixo AS INTEGER: steps AS INTEGER
  quadi AS INTEGER: quadf AS INTEGER
END TYPE
TYPE angs
  ex AS INTEGER: ey AS INTEGER: ez AS INTEGER
END TYPE
maxp = 100: maxob = 25: frames = 100: scriptlines = 100
DIM SHARED ponto(maxp, maxob) AS pnt, linha(maxp, maxob) AS lin, obj(maxp) AS objeto
DIM SHARED olho.x, olho.y, olho.z, olho.ax, olho.ay, olho.az, tob
DIM SHARED xmax, ymax, xmin, ymin, ax, ay, az, pdf(maxp), tl, var$(100)
DIM SHARED fax, fay, faz, fdx, fdy, fdz, fox, foy, foz, hierachy(maxob), hf
DIM SHARED eixox(maxob), eixoy(maxob), eixoz(maxob), fr
DIM SHARED script(scriptlines) AS scr, animat(frames, maxob) AS objanim
DIM SHARED scripts(scriptlines) AS scr, anguls(maxob) AS angs

fr = 30
getpoints arq1$
loadanim arq2$

'FOR i = 1 TO fr
'  PRINT animat(i, tob + 1).ax, animat(i, tob + 1).ay, animat(i, tob + 1).az
'  IF i > 22 THEN INPUT dh
'NEXT i

DIM SHARED px(maxp, tob), py(maxp, tob)

inicio:

'tabela de seno e cosseno
DIM SHARED seno(360), cose(360)
FOR i = 0 TO 360
  seno(i) = SIN(i * .0175)
  cose(i) = COS(i * .0175)
NEXT i

'=========
'Variaveis
'=========
'duas para page fliping
Ws = 1: Vs = 0
'angulos inicias
ax = fax: ay = fay: az = faz - 180
'deltas de rotao
deltax = fdx: deltay = fdy: deltaz = fdz
'Posiao do olho
olho.x = fox: olho.y = foy: olho.z = foz
opm = 2


FOR aaa = 1 TO tob
     aa = hierachy(aaa)
     roteixo aa
NEXT aaa

'=====================================================================
'                     LOOP       Principal
'=====================================================================

DO
  frame = frame + 1

  IF frame < fr + 1 THEN
  
  olho.x = animat(frame, tob + 1).olhox
  olho.y = animat(frame, tob + 1).olhoy
  olho.z = animat(frame, tob + 1).olhoz

  ax = animat(frame, tob + 1).ax
  ay = animat(frame, tob + 1).ay
  az = animat(frame, tob + 1).az - 180

  IF ax > 360 THEN ax = 0 + (ax - 360)
  IF ax < 0 THEN ax = 360 + ax
  IF ay > 360 THEN ay = 0 + (ay - 360)
  IF ay < 0 THEN ay = 360 + ay
  IF az > 360 THEN az = 0 + (az - 360)
  IF az < 0 THEN az = 360 + az
  
  FOR i = 1 TO tob
    obj(i).ax = animat(frame, i).eixox
    obj(i).ay = animat(frame, i).eixoy
    obj(i).az = animat(frame, i).eixoz
    
     FOR aaa = 1 TO tob
      aa = hierachy(aaa)
      roteixo aa
     NEXT aaa
  NEXT i
  ELSE
    sai = 1
  END IF

  SWAP Ws, Vs
  SCREEN 9, , Ws, Vs
  
  FOR aaa = 1 TO tob
   aa = hierachy(aaa)
   FOR l = 1 TO obj(aa).pf
     calctela l, aa, xtela, ytela
   NEXT l
  NEXT aaa
 
  CLS
  
  FOR ob = 1 TO tob
   FOR alin = 1 TO obj(ob).lf
     P = linha(alin, ob).pi
     pp = linha(alin, ob).pf
     LINE (px(P, ob), py(P, ob))-(px(pp, ob), py(pp, ob)), linha(alin, ob).cor
   NEXT alin
  NEXT ob

  WAIT &H3DA, 8

  x$ = INKEY$

  IF x$ <> "" THEN IF x$ = CHR$(27) THEN EXIT DO

  IF sai = 1 THEN
    SOUND 2000, .1
    SLEEP
    EXIT DO
  END IF

LOOP


SCREEN 0
LOCATE 1, 1: PRINT "Angulos dos objetos:"
FOR i = 1 TO tob
  PRINT i; "."; "x: "; obj(i).ax, "y: "; obj(i).ay, "z: "; obj(i).az
NEXT i
PRINT
PRINT "Posio do olho:"
PRINT "x: "; olho.x, "y: "; olho.y, "z: "; olho.z
PRINT
PRINT "Angulos do olho:"
PRINT "x: "; ax, "y: "; ay, "z: "; az - 180

SUB calctela (l, objt, xtela, ytela)

    FOR i = 2 TO hf
      IF objt = hierachy(i) THEN
        obps = hierachy(i - 1)
        nobps = i - 1
        GOTO ok
      END IF
    NEXT i
ok:

    aax = obj(objt).ax
    aay = obj(objt).ay
    aaz = obj(objt).az

    IF obj(objt).eixo = 1 THEN
      FOR ss = 1 TO nobps
        obps = hierachy(ss)
        aax = (aax + obj(obps).ax) MOD 360
        aay = (aay + obj(obps).ay) MOD 360
        aaz = (aaz + obj(obps).az) MOD 360
      NEXT ss
    END IF

    
    xxx = ponto(l, objt).x * cose(aax) - ponto(l, objt).y * seno(aax)
    yyy = ponto(l, objt).x * seno(aax) + ponto(l, objt).y * cose(aax)
    xi = xxx * cose(aay) + ponto(l, objt).z * seno(aay)
    zzz = -xxx * seno(aay) + ponto(l, objt).z * cose(aay)
    yi = yyy * cose(aaz) - ponto(l, objt).z * seno(aaz)
    zi = yi * seno(aaz) + zzz * cose(aaz)
    
    pontox = xi + obj(obps).eixox
    pontoy = yi + obj(obps).eixoy
    pontoz = zi + obj(obps).eixoz

    xnewb = pontox * cose(ax) - pontoy * seno(ax)
    ynewb = pontox * seno(ax) + pontoy * cose(ax)
    xb = xnewb * cose(ay) + pontoz * seno(ay)
    znb = -xnewb * seno(ay) + pontoz * cose(ay)
    yb = ynewb * cose(az) - znb * seno(az)
    zb = yb * seno(az) + znb * cose(az)

    xnew = xb * cose(olho.ax) - yb * seno(olho.ax)
    ynew = xb * seno(olho.ax) + yb * cose(olho.ax)
    x = xnew * cose(olho.ay) + zb * seno(olho.ay)
    zn = -xnew * seno(olho.ay) + zb * cose(olho.ay)
    y = ynew * cose(olho.az) - zn * seno(olho.az)
    z = y * seno(olho.az) + zn * cose(olho.az)

    xolho = x - olho.x
    yolho = y - olho.y
    zolho = z - olho.z
    
    xtela = ((xolho / zolho) * 640 + 390) * .8: px(l, objt) = xtela
    ytela = (yolho / zolho) * 350 + 175: py(l, objt) = ytela
END SUB

SUB getpoints (file$)
OPEN file$ FOR INPUT AS #1
LINE INPUT #1, header$
ver = VAL(RIGHT$(header$, 3))
IF ver < 3 THEN
  PRINT "Este programa  para arquivos v 3.0"
  END
END IF
IF LEFT$(header$, 16) <> "G Soft 3D file v" THEN
  BEEP
  PRINT "No  um arquivo G Soft 3D."
  END
END IF
LINE INPUT #1, totobfile$
tobfile = VAL(totobfile$)
objback:
tp = 0: tl = 0
LINE INPUT #1, lin$
obj = VAL(RIGHT$(lin$, 2))
obi$ = RIGHT$(STR$(obj), LEN(STR$(obj)) - 1)
a = INSTR(lin$, "-")
obj(obj).nome = LEFT$(lin$, a - 1)
DO WHILE NOT EOF(1)
  LINE INPUT #1, lin$
  IF lin$ = "fdp" GOTO linhas
  FOR i = 1 TO LEN(lin$)
    ch$ = MID$(lin$, i, 1)
    IF ch$ = "," THEN
      vr = vr + 1
      GOTO pula
    END IF
    var$(vr) = var$(vr) + ch$
pula:
  NEXT i
faz:
  tp = tp + 1
  ponto(tp, obj).x = VAL(var$(0))
  ponto(tp, obj).y = VAL(var$(1))
  ponto(tp, obj).z = VAL(var$(2))
  FOR aa = 0 TO 2
    var$(aa) = ""
  NEXT aa
  vr = 0
LOOP
linhas:
vr = 0
FOR aa = 0 TO 2
  var$(aa) = ""
NEXT aa
DO WHILE NOT EOF(1)
  LINE INPUT #1, lin$
  IF lin$ = "fdl" GOTO objetos
  FOR i = 1 TO LEN(lin$)
    ch$ = MID$(lin$, i, 1)
    IF ch$ = "'" THEN GOTO fazz
    IF ch$ = "," THEN
      vr = vr + 1
      GOTO apula
    END IF
    var$(vr) = var$(vr) + ch$
apula:
  NEXT i
fazz:
  tl = tl + 1
  linha(tl, obj).pi = VAL(var$(0))
  linha(tl, obj).pf = VAL(var$(1))
  linha(tl, obj).cor = VAL(var$(2))
  FOR aa = 0 TO 2
    var$(aa) = ""
  NEXT aa
  vr = 0
LOOP
objetos:
vr = 0
DO WHILE NOT EOF(1)
  LINE INPUT #1, lin$
  IF lin$ = "fdobj" + totobfile$ GOTO screensetup
  IF LEFT$(lin$, 5) = "fdobj" GOTO objback
  FOR i = 1 TO LEN(lin$)
    ch$ = MID$(lin$, i, 1)
    IF ch$ = "'" THEN GOTO faze
    IF ch$ = "," THEN
      vr = vr + 1
      GOTO pula2
    END IF
    var$(vr) = var$(vr) + ch$
pula2:
  NEXT i
faze:
  tob = tob + 1
  obj(tob).pf = tp
  obj(tob).lf = tl
  obj(tob).ax = VAL(var$(0))
  obj(tob).ay = VAL(var$(1))
  obj(tob).az = VAL(var$(2))
  obj(tob).pf = obj(tob).pf + 1
  ponto(obj(tob).pf, obj).x = VAL(var$(3))
  ponto(obj(tob).pf, obj).y = VAL(var$(4))
  ponto(obj(tob).pf, obj).z = VAL(var$(5))
  obj(tob).eixox = VAL(var$(3))
  obj(tob).eixoy = VAL(var$(4))
  obj(tob).eixoz = VAL(var$(5))
  obj(tob).eixo = VAL(var$(6))
  FOR aa = 0 TO 6
    var$(aa) = ""
  NEXT aa
  vr = 0
LOOP
screensetup:
vr = 0
DO WHILE NOT EOF(1)
LINE INPUT #1, lin$
IF lin$ = "eof" GOTO iniobjpos
ls = ls + 1
FOR i = 1 TO LEN(lin$)
    ch$ = MID$(lin$, i, 1)
    IF ch$ = "'" THEN GOTO fazi
    IF ch$ = "," THEN
      vr = vr + 1
      GOTO apula2
    END IF
    var$(vr) = var$(vr) + ch$
apula2:
NEXT i
fazi:
SELECT CASE ls
  CASE 1
    fax = VAL(var$(0))
    fay = VAL(var$(1))
    faz = VAL(var$(2))
    fdx = VAL(var$(3))
    fdy = VAL(var$(4))
    fdz = VAL(var$(5))
    fox = VAL(var$(6))
    foy = VAL(var$(7))
    foz = VAL(var$(8))
  CASE 2
    hierachy$ = lin$
END SELECT
LOOP
iniobjpos:
FOR aa = 0 TO 9
    var$(aa) = ""
NEXT aa
vr = 1
FOR i = 1 TO LEN(hierachy$)
    ch$ = MID$(hierachy$, i, 1)
    IF ch$ = "," THEN
      vr = vr + 1
      GOTO pula2a
    END IF
    var$(vr) = var$(vr) + ch$
pula2a:
NEXT i
FOR i = 1 TO vr - 1
  hierachy(i) = VAL(var$(i))
NEXT i
hf = vr - 1
CLOSE #1
END SUB

SUB loadanim (file$)
OPEN file$ FOR INPUT AS #1
LINE INPUT #1, header$
ver = VAL(RIGHT$(header$, 3))
IF LEFT$(header$, 26) <> "G Soft 3D animation file v" THEN
  BEEP
  PRINT "No  um arquivo de animao G Soft 3D."
  END
END IF
IF ver < 1 THEN
  PRINT "Este programa  para arquivos v 1.0"
  END
END IF
FOR aa = 0 TO 4
    var$(aa) = ""
NEXT aa
DO WHILE NOT EOF(1)
  LINE INPUT #1, lin$
  IF lin$ = "fdmo" GOTO proximo
  vr = 0
  FOR i = 1 TO LEN(lin$)
    ch$ = MID$(lin$, i, 1)
    IF ch$ = "," THEN
      vr = vr + 1
      GOTO spula
    END IF
    var$(vr) = var$(vr) + ch$
spula:
  NEXT i
  timo = timo + 1
  script(timo).obj = VAL(var$(0))
  script(timo).eixo = VAL(var$(1))
  script(timo).steps = VAL(var$(2))
  script(timo).quadi = VAL(var$(3))
  script(timo).quadf = VAL(var$(4))
  FOR aa = 0 TO 4
    var$(aa) = ""
  NEXT aa
  vr = 0
LOOP

proximo:
FOR aa = 0 TO 4
    var$(aa) = ""
NEXT aa
DO WHILE NOT EOF(1)
  LINE INPUT #1, lin$
  IF lin$ = "fdms" GOTO proximo2
  vr = 0
  FOR i = 1 TO LEN(lin$)
    ch$ = MID$(lin$, i, 1)
    IF ch$ = "," THEN
      vr = vr + 1
      GOTO aspula
    END IF
    var$(vr) = var$(vr) + ch$
aspula:
  NEXT i
  tis = tis + 1
  scripts(tis).obj = VAL(var$(0))
  scripts(tis).eixo = VAL(var$(1))
  scripts(tis).steps = VAL(var$(2))
  scripts(tis).quadi = VAL(var$(3))
  scripts(tis).quadf = VAL(var$(4))
  FOR aa = 0 TO 4
    var$(aa) = ""
  NEXT aa
  vr = 0
LOOP

proximo2:
LINE INPUT #1, totf$
fr = VAL(totf$)

FOR i = 1 TO fr
 FOR obj = 1 TO tob
  animat(i, obj).eixox = obj(obj).ax
  animat(i, obj).eixoy = obj(obj).ay
  animat(i, obj).eixoz = obj(obj).az
 NEXT obj
NEXT i

FOR i = 1 TO tob
  anguls(i).ex = obj(obj).ax
  anguls(i).ey = obj(obj).ay
  anguls(i).ez = obj(obj).az
NEXT i

FOR i = 1 TO timo
  obj = script(i).obj: stp = script(i).steps
  FOR f = script(i).quadi TO script(i).quadf
    SELECT CASE script(i).eixo
      CASE 1
        anguls(obj).ex = (anguls(obj).ex + stp) MOD 360
        IF anguls(obj).ex < 0 THEN anguls(obj).ex = 360 + anguls(obj).ex
        animat(f, obj).eixox = anguls(obj).ex
      CASE 2
        anguls(obj).ey = (anguls(obj).ey + stp) MOD 360
        IF anguls(obj).ey < 0 THEN anguls(obj).ey = 360 + anguls(obj).ey
        animat(f, obj).eixoy = anguls(obj).ey
      CASE 3
        anguls(obj).ez = (anguls(obj).ez + stp) MOD 360
        IF anguls(obj).ez < 0 THEN anguls(obj).ez = 360 + anguls(obj).ez
        animat(f, obj).eixoz = anguls(obj).ez
    END SELECT
  NEXT f
  FOR f = script(i).quadf + 1 TO fr
    animat(f, obj).eixox = anguls(obj).ex
    animat(f, obj).eixoy = anguls(obj).ey
    animat(f, obj).eixoz = anguls(obj).ez
  NEXT f
NEXT i



obj = tob + 1
FOR i = 1 TO fr
  animat(i, obj).olhox = fox
  animat(i, obj).olhoy = foy
  animat(i, obj).olhoz = foz
NEXT i

FOR i = 1 TO fr
  animat(i, obj).ax = fax
  animat(i, obj).ay = fay
  animat(i, obj).az = faz
NEXT i

FOR i = 1 TO tis
SELECT CASE scripts(i).obj
 CASE 1
  stp = scripts(i).steps
  ex = fox
  ey = foy
  ez = foz
  FOR f = scripts(i).quadi TO scripts(i).quadf
    SELECT CASE scripts(i).eixo
      CASE 1
        ex = ex + stp
        animat(f, obj).olhox = ex
      CASE 2
        ey = ey + stp
        animat(f, obj).olhoy = ey
      CASE 3
        ez = ez + stp
        animat(f, obj).olhoz = ez
    END SELECT
  NEXT f
  FOR f = scripts(i).quadf + 1 TO fr
    animat(f, obj).olhox = ex
    animat(f, obj).olhoy = ey
    animat(f, obj).olhoz = ez
  NEXT f
 CASE 2
  stp = scripts(i).steps
  ex = fax
  ey = fay
  ez = faz
  FOR f = scripts(i).quadi TO scripts(i).quadf
    SELECT CASE scripts(i).eixo
      CASE 1
        ex = ex + stp
        animat(f, obj).ax = ex
      CASE 2
        ey = ey + stp
        animat(f, obj).ay = ey
      CASE 3
        ez = ez + stp
        animat(f, obj).az = ez
    END SELECT
  NEXT f
  FOR f = scripts(i).quadf + 1 TO fr
    animat(f, obj).ax = ex
    animat(f, obj).ay = ey
    animat(f, obj).az = ez
  NEXT f
END SELECT
NEXT i
END SUB

SUB roteixo (objt)

    FOR i = 2 TO hf
      IF objt = hierachy(i) THEN
        obps = hierachy(i - 1)
        GOTO aok
      END IF
    NEXT i
aok:

    aax = obj(objt).ax
    aay = obj(objt).ay
    aaz = obj(objt).az

    IF obj(obps).eixo = 1 THEN
      aax = (aax + obj(obps).ax) MOD 360
      aay = (aay + obj(obps).ay) MOD 360
      aaz = (aaz + obj(obps).az) MOD 360
    END IF
    
    l = obj(objt).pf

    xxx = ponto(l, objt).x * cose(aax) - ponto(l, objt).y * seno(aax)
    yyy = ponto(l, objt).x * seno(aax) + ponto(l, objt).y * cose(aax)
    obj(objt).eixox = xxx * cose(aay) + ponto(l, objt).z * seno(aay)
    zzz = -xxx * seno(aay) + ponto(l, objt).z * cose(aay)
    obj(objt).eixoy = yyy * cose(aaz) - ponto(l, objt).z * seno(aaz)
    obj(objt).eixoz = obj(objt).eixoy * seno(aaz) + zzz * cose(aaz)

    obj(objt).eixox = obj(objt).eixox + obj(obps).eixox
    obj(objt).eixoy = obj(objt).eixoy + obj(obps).eixoy
    obj(objt).eixoz = obj(objt).eixoz + obj(obps).eixoz
END SUB

